;;; thingatpt-utils-test.el  --- more thing-at-point edit functions

;; Version: 1.5

;; Copyright (C) 2006, 2007 Andreas Roehler

;; Author: Andreas Roehler <andreas.roehler@easy-emacs.de>

;; Keywords: convenience

;; This file is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; This file is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to
;; the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
;; Boston, MA 02110-1301, USA.

;;; Commentary:

;; Information is given with thingatpt-utils-base.el

(require 'thingatpt-utils-base)




(defun thatpt-test (&optional arg) 
  "Checks available THING-atpt forms at point
  Prints forms with values in bufffer `thatpt-test', 
  with ARG also forms, which returned `nil' "
  (interactive "P")
  (let 
      ((pos (point)) 
       (thatpt-fnlist '(
			list-atpt
			bounds-of-list-atpt
			list-atpt-beginning-position
			list-atpt-end-position
			copy-list-atpt
			list-bfpt
			bounds-of-list-bfpt
			list-bfpt-beginning-position
			list-bfpt-end-position
			copy-list-bfpt
			list-afpt
			bounds-of-list-afpt
			list-afpt-beginning-position
			list-afpt-end-position
			copy-list-afpt
			symbol-atpt
			bounds-of-symbol-atpt
			symbol-atpt-beginning-position
			symbol-atpt-end-position
			copy-symbol-atpt
			symbol-bfpt
			bounds-of-symbol-bfpt
			symbol-bfpt-beginning-position
			symbol-bfpt-end-position
			copy-symbol-bfpt
			symbol-afpt
			bounds-of-symbol-afpt
			symbol-afpt-beginning-position
			symbol-afpt-end-position
			copy-symbol-afpt
			word-atpt
			bounds-of-word-atpt
			word-atpt-beginning-position
			word-atpt-end-position
			copy-word-atpt
			word-bfpt
			bounds-of-word-bfpt
			word-bfpt-beginning-position
			word-bfpt-end-position
			copy-word-bfpt
			word-afpt
			bounds-of-word-afpt
			word-afpt-beginning-position
			word-afpt-end-position
			copy-word-afpt
			sexp-atpt
			bounds-of-sexp-atpt
			sexp-atpt-beginning-position
			sexp-atpt-end-position
			copy-sexp-atpt
			sexp-bfpt
			bounds-of-sexp-bfpt
			sexp-bfpt-beginning-position
			sexp-bfpt-end-position
			copy-sexp-bfpt
			sexp-afpt
			bounds-of-sexp-afpt
			sexp-afpt-beginning-position
			sexp-afpt-end-position
			copy-sexp-afpt
			paragraph-atpt
			bounds-of-paragraph-atpt
			paragraph-atpt-beginning-position
			paragraph-atpt-end-position
			copy-paragraph-atpt
			paragraph-bfpt
			bounds-of-paragraph-bfpt
			paragraph-bfpt-beginning-position
			paragraph-bfpt-end-position
			copy-paragraph-bfpt
			paragraph-afpt
			bounds-of-paragraph-afpt
			paragraph-afpt-beginning-position
			paragraph-afpt-end-position
			copy-paragraph-afpt
			string-atpt
			bounds-of-string-atpt
			string-atpt-beginning-position
			string-atpt-end-position
			copy-string-atpt
			string-bfpt
			bounds-of-string-bfpt
			string-bfpt-beginning-position
			string-bfpt-end-position
			copy-string-bfpt
			string-afpt
			bounds-of-string-afpt
			string-afpt-beginning-position
			string-afpt-end-position
			copy-string-afpt
			line-atpt
			bounds-of-line-atpt
			line-atpt-beginning-position
			line-atpt-end-position
			copy-line-atpt
			line-bfpt
			bounds-of-line-bfpt
			line-bfpt-beginning-position
			line-bfpt-end-position
			copy-line-bfpt
			line-afpt
			bounds-of-line-afpt
			line-afpt-beginning-position
			line-afpt-end-position
			copy-line-afpt
			sentence-atpt
			bounds-of-sentence-atpt
			sentence-atpt-beginning-position
			sentence-atpt-end-position
			copy-sentence-atpt
			sentence-bfpt
			bounds-of-sentence-bfpt
			sentence-bfpt-beginning-position
			sentence-bfpt-end-position
			copy-sentence-bfpt
			sentence-afpt
			bounds-of-sentence-afpt
			sentence-afpt-beginning-position
			sentence-afpt-end-position
			copy-sentence-afpt
			defun-atpt
			bounds-of-defun-atpt
			defun-atpt-beginning-position
			defun-atpt-end-position
			copy-defun-atpt
			defun-bfpt
			bounds-of-defun-bfpt
			defun-bfpt-beginning-position
			defun-bfpt-end-position
			copy-defun-bfpt
			defun-afpt
			bounds-of-defun-afpt
			defun-afpt-beginning-position
			defun-afpt-end-position
			copy-defun-afpt
			email-atpt
			bounds-of-email-atpt
			email-atpt-beginning-position
			email-atpt-end-position
			copy-email-atpt
			email-bfpt
			bounds-of-email-bfpt
			email-bfpt-beginning-position
			email-bfpt-end-position
			copy-email-bfpt
			email-afpt
			bounds-of-email-afpt
			email-afpt-beginning-position
			email-afpt-end-position
			copy-email-afpt
			csv-atpt
			bounds-of-csv-atpt
			csv-atpt-beginning-position
			csv-atpt-end-position
			copy-csv-atpt
			csv-bfpt
			bounds-of-csv-bfpt
			csv-bfpt-beginning-position
			csv-bfpt-end-position
			copy-csv-bfpt
			csv-afpt
			bounds-of-csv-afpt
			csv-afpt-beginning-position
			csv-afpt-end-position
			copy-csv-afpt
			phone-atpt
			bounds-of-phone-atpt
			phone-atpt-beginning-position
			phone-atpt-end-position
			copy-phone-atpt
			phone-bfpt
			bounds-of-phone-bfpt
			phone-bfpt-beginning-position
			phone-bfpt-end-position
			copy-phone-bfpt
			phone-afpt
			bounds-of-phone-afpt
			phone-afpt-beginning-position
			phone-afpt-end-position
			copy-phone-afpt
			ml-text-atpt
			bounds-of-ml-text-atpt
			ml-text-atpt-beginning-position
			ml-text-atpt-end-position
			copy-ml-text-atpt
			ml-text-bfpt
			bounds-of-ml-text-bfpt
			ml-text-bfpt-beginning-position
			ml-text-bfpt-end-position
			copy-ml-text-bfpt
			ml-text-afpt
			bounds-of-ml-text-afpt
			ml-text-afpt-beginning-position
			ml-text-afpt-end-position
			copy-ml-text-afpt
			filename-atpt
			bounds-of-filename-atpt
			filename-atpt-beginning-position
			filename-atpt-end-position
			copy-filename-atpt
			filename-bfpt
			bounds-of-filename-bfpt
			filename-bfpt-beginning-position
			filename-bfpt-end-position
			copy-filename-bfpt
			filename-afpt
			bounds-of-filename-afpt
			filename-afpt-beginning-position
			filename-afpt-end-position
			copy-filename-afpt
			url-atpt
			bounds-of-url-atpt
			url-atpt-beginning-position
			url-atpt-end-position
			copy-url-atpt
			url-bfpt
			bounds-of-url-bfpt
			url-bfpt-beginning-position
			url-bfpt-end-position
			copy-url-bfpt
			url-afpt
			bounds-of-url-afpt
			url-afpt-beginning-position
			url-afpt-end-position
			copy-url-afpt
			isbn-atpt
			bounds-of-isbn-atpt
			isbn-atpt-beginning-position
			isbn-atpt-end-position
			copy-isbn-atpt
			isbn-bfpt
			bounds-of-isbn-bfpt
			isbn-bfpt-beginning-position
			isbn-bfpt-end-position
			copy-isbn-bfpt
			isbn-afpt
			bounds-of-isbn-afpt
			isbn-afpt-beginning-position
			isbn-afpt-end-position
			copy-isbn-afpt
			date-atpt
			bounds-of-date-atpt
			date-atpt-beginning-position
			date-atpt-end-position
			copy-date-atpt
			date-bfpt
			bounds-of-date-bfpt
			date-bfpt-beginning-position
			date-bfpt-end-position
			copy-date-bfpt
			date-afpt
			bounds-of-date-afpt
			date-afpt-beginning-position
			date-afpt-end-position
			copy-date-afpt
			number-atpt
			bounds-of-number-atpt
			number-atpt-beginning-position
			number-atpt-end-position
			copy-number-atpt
			number-bfpt
			bounds-of-number-bfpt
			number-bfpt-beginning-position
			number-bfpt-end-position
			copy-number-bfpt
			number-afpt
			bounds-of-number-afpt
			number-afpt-beginning-position
			number-afpt-end-position
			copy-number-afpt
			float-atpt
			bounds-of-float-atpt
			float-atpt-beginning-position
			float-atpt-end-position
			copy-float-atpt
			float-bfpt
			bounds-of-float-bfpt
			float-bfpt-beginning-position
			float-bfpt-end-position
			copy-float-bfpt
			float-afpt
			bounds-of-float-afpt
			float-afpt-beginning-position
			float-afpt-end-position
			copy-float-afpt
			page-atpt
			bounds-of-page-atpt
			page-atpt-beginning-position
			page-atpt-end-position
			copy-page-atpt
			page-bfpt
			bounds-of-page-bfpt
			page-bfpt-beginning-position
			page-bfpt-end-position
			copy-page-bfpt
			page-afpt
			bounds-of-page-afpt
			page-afpt-beginning-position
			page-afpt-end-position
			copy-page-afpt
			whitespace-atpt
			bounds-of-whitespace-atpt
			whitespace-atpt-beginning-position
			whitespace-atpt-end-position
			copy-whitespace-atpt
			whitespace-bfpt
			bounds-of-whitespace-bfpt
			whitespace-bfpt-beginning-position
			whitespace-bfpt-end-position
			copy-whitespace-bfpt
			whitespace-afpt
			bounds-of-whitespace-afpt
			whitespace-afpt-beginning-position
			whitespace-afpt-end-position
			copy-whitespace-afpt
			alnum-atpt
			bounds-of-alnum-atpt
			alnum-atpt-beginning-position
			alnum-atpt-end-position
			copy-alnum-atpt
			alnum-bfpt
			bounds-of-alnum-bfpt
			alnum-bfpt-beginning-position
			alnum-bfpt-end-position
			copy-alnum-bfpt
			alnum-afpt
			bounds-of-alnum-afpt
			alnum-afpt-beginning-position
			alnum-afpt-end-position
			copy-alnum-afpt
			alpha-atpt
			bounds-of-alpha-atpt
			alpha-atpt-beginning-position
			alpha-atpt-end-position
			copy-alpha-atpt
			alpha-bfpt
			bounds-of-alpha-bfpt
			alpha-bfpt-beginning-position
			alpha-bfpt-end-position
			copy-alpha-bfpt
			alpha-afpt
			bounds-of-alpha-afpt
			alpha-afpt-beginning-position
			alpha-afpt-end-position
			copy-alpha-afpt
			ascii-atpt
			bounds-of-ascii-atpt
			ascii-atpt-beginning-position
			ascii-atpt-end-position
			copy-ascii-atpt
			ascii-bfpt
			bounds-of-ascii-bfpt
			ascii-bfpt-beginning-position
			ascii-bfpt-end-position
			copy-ascii-bfpt
			ascii-afpt
			bounds-of-ascii-afpt
			ascii-afpt-beginning-position
			ascii-afpt-end-position
			copy-ascii-afpt
			blank-atpt
			bounds-of-blank-atpt
			blank-atpt-beginning-position
			blank-atpt-end-position
			copy-blank-atpt
			blank-bfpt
			bounds-of-blank-bfpt
			blank-bfpt-beginning-position
			blank-bfpt-end-position
			copy-blank-bfpt
			blank-afpt
			bounds-of-blank-afpt
			blank-afpt-beginning-position
			blank-afpt-end-position
			copy-blank-afpt
			cntrl-atpt
			bounds-of-cntrl-atpt
			cntrl-atpt-beginning-position
			cntrl-atpt-end-position
			copy-cntrl-atpt
			cntrl-bfpt
			bounds-of-cntrl-bfpt
			cntrl-bfpt-beginning-position
			cntrl-bfpt-end-position
			copy-cntrl-bfpt
			cntrl-afpt
			bounds-of-cntrl-afpt
			cntrl-afpt-beginning-position
			cntrl-afpt-end-position
			copy-cntrl-afpt
			digit-atpt
			bounds-of-digit-atpt
			digit-atpt-beginning-position
			digit-atpt-end-position
			copy-digit-atpt
			digit-bfpt
			bounds-of-digit-bfpt
			digit-bfpt-beginning-position
			digit-bfpt-end-position
			copy-digit-bfpt
			digit-afpt
			bounds-of-digit-afpt
			digit-afpt-beginning-position
			digit-afpt-end-position
			copy-digit-afpt
			graph-atpt
			bounds-of-graph-atpt
			graph-atpt-beginning-position
			graph-atpt-end-position
			copy-graph-atpt
			graph-bfpt
			bounds-of-graph-bfpt
			graph-bfpt-beginning-position
			graph-bfpt-end-position
			copy-graph-bfpt
			graph-afpt
			bounds-of-graph-afpt
			graph-afpt-beginning-position
			graph-afpt-end-position
			copy-graph-afpt
			lower-atpt
			bounds-of-lower-atpt
			lower-atpt-beginning-position
			lower-atpt-end-position
			copy-lower-atpt
			lower-bfpt
			bounds-of-lower-bfpt
			lower-bfpt-beginning-position
			lower-bfpt-end-position
			copy-lower-bfpt
			lower-afpt
			bounds-of-lower-afpt
			lower-afpt-beginning-position
			lower-afpt-end-position
			copy-lower-afpt
			multibyte-atpt
			bounds-of-multibyte-atpt
			multibyte-atpt-beginning-position
			multibyte-atpt-end-position
			copy-multibyte-atpt
			multibyte-bfpt
			bounds-of-multibyte-bfpt
			multibyte-bfpt-beginning-position
			multibyte-bfpt-end-position
			copy-multibyte-bfpt
			multibyte-afpt
			bounds-of-multibyte-afpt
			multibyte-afpt-beginning-position
			multibyte-afpt-end-position
			copy-multibyte-afpt
			nonascii-atpt
			bounds-of-nonascii-atpt
			nonascii-atpt-beginning-position
			nonascii-atpt-end-position
			copy-nonascii-atpt
			nonascii-bfpt
			bounds-of-nonascii-bfpt
			nonascii-bfpt-beginning-position
			nonascii-bfpt-end-position
			copy-nonascii-bfpt
			nonascii-afpt
			bounds-of-nonascii-afpt
			nonascii-afpt-beginning-position
			nonascii-afpt-end-position
			copy-nonascii-afpt
			print-atpt
			bounds-of-print-atpt
			print-atpt-beginning-position
			print-atpt-end-position
			copy-print-atpt
			print-bfpt
			bounds-of-print-bfpt
			print-bfpt-beginning-position
			print-bfpt-end-position
			copy-print-bfpt
			print-afpt
			bounds-of-print-afpt
			print-afpt-beginning-position
			print-afpt-end-position
			copy-print-afpt
			punct-atpt
			bounds-of-punct-atpt
			punct-atpt-beginning-position
			punct-atpt-end-position
			copy-punct-atpt
			punct-bfpt
			bounds-of-punct-bfpt
			punct-bfpt-beginning-position
			punct-bfpt-end-position
			copy-punct-bfpt
			punct-afpt
			bounds-of-punct-afpt
			punct-afpt-beginning-position
			punct-afpt-end-position
			copy-punct-afpt
			space-atpt
			bounds-of-space-atpt
			space-atpt-beginning-position
			space-atpt-end-position
			copy-space-atpt
			space-bfpt
			bounds-of-space-bfpt
			space-bfpt-beginning-position
			space-bfpt-end-position
			copy-space-bfpt
			space-afpt
			bounds-of-space-afpt
			space-afpt-beginning-position
			space-afpt-end-position
			copy-space-afpt
			unibyte-atpt
			bounds-of-unibyte-atpt
			unibyte-atpt-beginning-position
			unibyte-atpt-end-position
			copy-unibyte-atpt
			unibyte-bfpt
			bounds-of-unibyte-bfpt
			unibyte-bfpt-beginning-position
			unibyte-bfpt-end-position
			copy-unibyte-bfpt
			unibyte-afpt
			bounds-of-unibyte-afpt
			unibyte-afpt-beginning-position
			unibyte-afpt-end-position
			copy-unibyte-afpt
			upper-atpt
			bounds-of-upper-atpt
			upper-atpt-beginning-position
			upper-atpt-end-position
			copy-upper-atpt
			upper-bfpt
			bounds-of-upper-bfpt
			upper-bfpt-beginning-position
			upper-bfpt-end-position
			copy-upper-bfpt
			upper-afpt
			bounds-of-upper-afpt
			upper-afpt-beginning-position
			upper-afpt-end-position
			copy-upper-afpt
			xdigit-atpt
			bounds-of-xdigit-atpt
			xdigit-atpt-beginning-position
			xdigit-atpt-end-position
			copy-xdigit-atpt
xdigit-bfpt
bounds-of-xdigit-bfpt
xdigit-bfpt-beginning-position
xdigit-bfpt-end-position
copy-xdigit-bfpt
xdigit-afpt
bounds-of-xdigit-afpt
xdigit-afpt-beginning-position
xdigit-afpt-end-position
copy-xdigit-afpt
region-atpt
bounds-of-region-atpt
region-atpt-beginning-position
region-atpt-end-position
copy-region-atpt
region-bfpt
bounds-of-region-bfpt
region-bfpt-beginning-position
region-bfpt-end-position
copy-region-bfpt
region-afpt
bounds-of-region-afpt
region-afpt-beginning-position
region-afpt-end-position
copy-region-afpt
delimited-atpt
bounds-of-delimited-atpt
delimited-atpt-beginning-position
delimited-atpt-end-position
copy-delimited-atpt
delimited-bfpt
bounds-of-delimited-bfpt
delimited-bfpt-beginning-position
delimited-bfpt-end-position
copy-delimited-bfpt
delimited-afpt
bounds-of-delimited-afpt
delimited-afpt-beginning-position
delimited-afpt-end-position
copy-delimited-afpt)))
    (save-excursion 
      (set-buffer (get-buffer-create "thatpt-test"))
      (erase-buffer)
      (insert (format "Point: %s" pos))
      ;;     (end-of-line) 
      (newline)) 
    (dolist (elt thatpt-fnlist)
      (let* ((item (funcall elt))
	     (output-p (if arg
			   t
			 (cond ((eq nil item)
				nil)
			       ((and (listp item)
				     (eq nil (car item)))
				nil)
			       ((and (stringp item)
				     (string= "" item))
				nil)
			       (t t)))))
	(when output-p
	  (save-excursion 
	    (switch-to-buffer "thatpt-test")
	    (if (listp item)
		(setq item (concat (format "%s" (car item))" "(format "%s" (cdr item)))))
	    (insert (concat (format "%s: " elt) (format "%s \n" item)))))))))

(defun thatpt-mv-test ()
  "Checks available move-THING-atpt forms at point.
  Shows moves while indicating executed form in message-buffer"
  (interactive)
  (let 
      (
       (thatpt-mv-fnlist '(
			   forward-list-atpt
			   backward-list-atpt
			   forward-symbol-atpt
			   backward-symbol-atpt
			   forward-word-atpt
			   backward-word-atpt
			   forward-sexp-atpt
			   backward-sexp-atpt
			   forward-paragraph-atpt
			   backward-paragraph-atpt
			   forward-string-atpt
			   backward-string-atpt
			   forward-line-atpt
			   backward-line-atpt
			   forward-sentence-atpt
			   backward-sentence-atpt
			   forward-defun-atpt
			   backward-defun-atpt
			   forward-email-atpt
			   backward-email-atpt
			   forward-csv-atpt
			   backward-csv-atpt
			   forward-phone-atpt
			   backward-phone-atpt
			   forward-ml-text-atpt
			   backward-ml-text-atpt
			   forward-filename-atpt
			   backward-filename-atpt
			   forward-url-atpt
			   backward-url-atpt
			   forward-isbn-atpt
			   backward-isbn-atpt
			   forward-date-atpt
			   backward-date-atpt
			   forward-number-atpt
			   backward-number-atpt
			   forward-float-atpt
			   backward-float-atpt
			   forward-page-atpt
			   backward-page-atpt
			   forward-whitespace-atpt
			   backward-whitespace-atpt
			   forward-alnum-atpt
			   backward-alnum-atpt
			   forward-alpha-atpt
			   backward-alpha-atpt
			   forward-ascii-atpt
			   backward-ascii-atpt
			   forward-blank-atpt
			   backward-blank-atpt
			   forward-cntrl-atpt
			   backward-cntrl-atpt
			   forward-digit-atpt
			   backward-digit-atpt
			   forward-graph-atpt
			   backward-graph-atpt
			   forward-lower-atpt
			   backward-lower-atpt
			   forward-multibyte-atpt
			   backward-multibyte-atpt
			   forward-nonascii-atpt
			   backward-nonascii-atpt
			   forward-print-atpt
			   backward-print-atpt
			   forward-punct-atpt
			   backward-punct-atpt
			   forward-space-atpt
			   backward-space-atpt
			   forward-unibyte-atpt
			   backward-unibyte-atpt
			   forward-upper-atpt
			   backward-upper-atpt
forward-xdigit-atpt
backward-xdigit-atpt
forward-region-atpt
backward-region-atpt
forward-delimited-atpt
backward-delimited-atpt)))
    (save-excursion 
      (dolist (elt thatpt-mv-fnlist)
	(when
	    (functionp (intern-soft elt))
	  (message "   %s" elt)
	  (save-excursion
	    (funcall elt)
	    (sit-for thatpt-mv-test-delay))))))
  (message "   %s" "Seems as thatpt-mv-test completed successfully!"))

;; (setq delim-thingsatpt-fn 'symbol-atpt)

(defcustom thatpt-delimtest-delay  1 
  "Seconds to wait until next delimtest functioncall" 
  
  :type 'number
  :group 'convenience)

(defcustom thatpt-mv-test-delay 1 
  "" 
  :type 'number
  :group 'convenience)

(defun thatpt-delimtest () 
  " "
  (interactive)
  (let ((pos (point))
	(fns-test '(
		    doublequote-list-atpt
		    singlequote-list-atpt
		    parenthese-list-atpt
		    brace-list-atpt
		    bracket-list-atpt
		    doublequote-list-bfpt
		    singlequote-list-bfpt
		    parenthese-list-bfpt
		    brace-list-bfpt
		    bracket-list-bfpt
		    doublequote-list-afpt
		    singlequote-list-afpt
		    parenthese-list-afpt
		    brace-list-afpt
		    bracket-list-afpt
		    separate-list-atpt
		    comment-list-atpt
		    separate-list-bfpt
		    comment-list-bfpt
		    separate-list-afpt
		    comment-list-afpt
		    doublequote-symbol-atpt
		    singlequote-symbol-atpt
		    parenthese-symbol-atpt
		    brace-symbol-atpt
		    bracket-symbol-atpt
		    doublequote-symbol-bfpt
		    singlequote-symbol-bfpt
		    parenthese-symbol-bfpt
		    brace-symbol-bfpt
		    bracket-symbol-bfpt
		    doublequote-symbol-afpt
		    singlequote-symbol-afpt
		    parenthese-symbol-afpt
		    brace-symbol-afpt
		    bracket-symbol-afpt
		    separate-symbol-atpt
		    comment-symbol-atpt
		    separate-symbol-bfpt
		    comment-symbol-bfpt
		    separate-symbol-afpt
		    comment-symbol-afpt
		    doublequote-word-atpt
		    singlequote-word-atpt
		    parenthese-word-atpt
		    brace-word-atpt
		    bracket-word-atpt
		    doublequote-word-bfpt
		    singlequote-word-bfpt
		    parenthese-word-bfpt
		    brace-word-bfpt
		    bracket-word-bfpt
		    doublequote-word-afpt
		    singlequote-word-afpt
		    parenthese-word-afpt
		    brace-word-afpt
		    bracket-word-afpt
		    separate-word-atpt
		    comment-word-atpt
		    separate-word-bfpt
		    comment-word-bfpt
		    separate-word-afpt
		    comment-word-afpt
		    doublequote-sexp-atpt
		    singlequote-sexp-atpt
		    parenthese-sexp-atpt
		    brace-sexp-atpt
		    bracket-sexp-atpt
		    doublequote-sexp-bfpt
		    singlequote-sexp-bfpt
		    parenthese-sexp-bfpt
		    brace-sexp-bfpt
		    bracket-sexp-bfpt
		    doublequote-sexp-afpt
		    singlequote-sexp-afpt
		    parenthese-sexp-afpt
		    brace-sexp-afpt
		    bracket-sexp-afpt
		    separate-sexp-atpt
		    comment-sexp-atpt
		    separate-sexp-bfpt
		    comment-sexp-bfpt
		    separate-sexp-afpt
		    comment-sexp-afpt
		    doublequote-paragraph-atpt
		    singlequote-paragraph-atpt
		    parenthese-paragraph-atpt
		    brace-paragraph-atpt
		    bracket-paragraph-atpt
		    doublequote-paragraph-bfpt
		    singlequote-paragraph-bfpt
		    parenthese-paragraph-bfpt
		    brace-paragraph-bfpt
		    bracket-paragraph-bfpt
		    doublequote-paragraph-afpt
		    singlequote-paragraph-afpt
		    parenthese-paragraph-afpt
		    brace-paragraph-afpt
		    bracket-paragraph-afpt
		    separate-paragraph-atpt
		    comment-paragraph-atpt
		    separate-paragraph-bfpt
		    comment-paragraph-bfpt
		    separate-paragraph-afpt
		    comment-paragraph-afpt
		    doublequote-string-atpt
		    singlequote-string-atpt
		    parenthese-string-atpt
		    brace-string-atpt
		    bracket-string-atpt
		    doublequote-string-bfpt
		    singlequote-string-bfpt
		    parenthese-string-bfpt
		    brace-string-bfpt
		    bracket-string-bfpt
		    doublequote-string-afpt
		    singlequote-string-afpt
		    parenthese-string-afpt
		    brace-string-afpt
		    bracket-string-afpt
		    separate-string-atpt
		    comment-string-atpt
		    separate-string-bfpt
		    comment-string-bfpt
		    separate-string-afpt
		    comment-string-afpt
		    doublequote-line-atpt
		    singlequote-line-atpt
		    parenthese-line-atpt
		    brace-line-atpt
		    bracket-line-atpt
		    doublequote-line-bfpt
		    singlequote-line-bfpt
		    parenthese-line-bfpt
		    brace-line-bfpt
		    bracket-line-bfpt
		    doublequote-line-afpt
		    singlequote-line-afpt
		    parenthese-line-afpt
		    brace-line-afpt
		    bracket-line-afpt
		    separate-line-atpt
		    comment-line-atpt
		    separate-line-bfpt
		    comment-line-bfpt
		    separate-line-afpt
		    comment-line-afpt
		    doublequote-sentence-atpt
		    singlequote-sentence-atpt
		    parenthese-sentence-atpt
		    brace-sentence-atpt
		    bracket-sentence-atpt
		    doublequote-sentence-bfpt
		    singlequote-sentence-bfpt
		    parenthese-sentence-bfpt
		    brace-sentence-bfpt
		    bracket-sentence-bfpt
		    doublequote-sentence-afpt
		    singlequote-sentence-afpt
		    parenthese-sentence-afpt
		    brace-sentence-afpt
		    bracket-sentence-afpt
		    separate-sentence-atpt
		    comment-sentence-atpt
		    separate-sentence-bfpt
		    comment-sentence-bfpt
		    separate-sentence-afpt
		    comment-sentence-afpt
		    doublequote-defun-atpt
		    singlequote-defun-atpt
		    parenthese-defun-atpt
		    brace-defun-atpt
		    bracket-defun-atpt
		    doublequote-defun-bfpt
		    singlequote-defun-bfpt
		    parenthese-defun-bfpt
		    brace-defun-bfpt
		    bracket-defun-bfpt
		    doublequote-defun-afpt
		    singlequote-defun-afpt
		    parenthese-defun-afpt
		    brace-defun-afpt
		    bracket-defun-afpt
		    separate-defun-atpt
		    comment-defun-atpt
		    separate-defun-bfpt
		    comment-defun-bfpt
		    separate-defun-afpt
		    comment-defun-afpt
		    doublequote-email-atpt
		    singlequote-email-atpt
		    parenthese-email-atpt
		    brace-email-atpt
		    bracket-email-atpt
		    doublequote-email-bfpt
		    singlequote-email-bfpt
		    parenthese-email-bfpt
		    brace-email-bfpt
		    bracket-email-bfpt
		    doublequote-email-afpt
		    singlequote-email-afpt
		    parenthese-email-afpt
		    brace-email-afpt
		    bracket-email-afpt
		    separate-email-atpt
		    comment-email-atpt
		    separate-email-bfpt
		    comment-email-bfpt
		    separate-email-afpt
		    comment-email-afpt
		    doublequote-csv-atpt
		    singlequote-csv-atpt
		    parenthese-csv-atpt
		    brace-csv-atpt
		    bracket-csv-atpt
		    doublequote-csv-bfpt
		    singlequote-csv-bfpt
		    parenthese-csv-bfpt
		    brace-csv-bfpt
		    bracket-csv-bfpt
		    doublequote-csv-afpt
		    singlequote-csv-afpt
		    parenthese-csv-afpt
		    brace-csv-afpt
		    bracket-csv-afpt
		    separate-csv-atpt
		    comment-csv-atpt
		    separate-csv-bfpt
		    comment-csv-bfpt
		    separate-csv-afpt
		    comment-csv-afpt
		    doublequote-phone-atpt
		    singlequote-phone-atpt
		    parenthese-phone-atpt
		    brace-phone-atpt
		    bracket-phone-atpt
		    doublequote-phone-bfpt
		    singlequote-phone-bfpt
		    parenthese-phone-bfpt
		    brace-phone-bfpt
		    bracket-phone-bfpt
		    doublequote-phone-afpt
		    singlequote-phone-afpt
		    parenthese-phone-afpt
		    brace-phone-afpt
		    bracket-phone-afpt
		    separate-phone-atpt
		    comment-phone-atpt
		    separate-phone-bfpt
		    comment-phone-bfpt
		    separate-phone-afpt
		    comment-phone-afpt
		    doublequote-ml-text-atpt
		    singlequote-ml-text-atpt
		    parenthese-ml-text-atpt
		    brace-ml-text-atpt
		    bracket-ml-text-atpt
		    doublequote-ml-text-bfpt
		    singlequote-ml-text-bfpt
		    parenthese-ml-text-bfpt
		    brace-ml-text-bfpt
		    bracket-ml-text-bfpt
		    doublequote-ml-text-afpt
		    singlequote-ml-text-afpt
		    parenthese-ml-text-afpt
		    brace-ml-text-afpt
		    bracket-ml-text-afpt
		    separate-ml-text-atpt
		    comment-ml-text-atpt
		    separate-ml-text-bfpt
		    comment-ml-text-bfpt
		    separate-ml-text-afpt
		    comment-ml-text-afpt
		    doublequote-filename-atpt
		    singlequote-filename-atpt
		    parenthese-filename-atpt
		    brace-filename-atpt
		    bracket-filename-atpt
		    doublequote-filename-bfpt
		    singlequote-filename-bfpt
		    parenthese-filename-bfpt
		    brace-filename-bfpt
		    bracket-filename-bfpt
		    doublequote-filename-afpt
		    singlequote-filename-afpt
		    parenthese-filename-afpt
		    brace-filename-afpt
		    bracket-filename-afpt
		    separate-filename-atpt
		    comment-filename-atpt
		    separate-filename-bfpt
		    comment-filename-bfpt
		    separate-filename-afpt
		    comment-filename-afpt
		    doublequote-url-atpt
		    singlequote-url-atpt
		    parenthese-url-atpt
		    brace-url-atpt
		    bracket-url-atpt
		    doublequote-url-bfpt
		    singlequote-url-bfpt
		    parenthese-url-bfpt
		    brace-url-bfpt
		    bracket-url-bfpt
		    doublequote-url-afpt
		    singlequote-url-afpt
		    parenthese-url-afpt
		    brace-url-afpt
		    bracket-url-afpt
		    separate-url-atpt
		    comment-url-atpt
		    separate-url-bfpt
		    comment-url-bfpt
		    separate-url-afpt
		    comment-url-afpt
		    doublequote-isbn-atpt
		    singlequote-isbn-atpt
		    parenthese-isbn-atpt
		    brace-isbn-atpt
		    bracket-isbn-atpt
		    doublequote-isbn-bfpt
		    singlequote-isbn-bfpt
		    parenthese-isbn-bfpt
		    brace-isbn-bfpt
		    bracket-isbn-bfpt
		    doublequote-isbn-afpt
		    singlequote-isbn-afpt
		    parenthese-isbn-afpt
		    brace-isbn-afpt
		    bracket-isbn-afpt
		    separate-isbn-atpt
		    comment-isbn-atpt
		    separate-isbn-bfpt
		    comment-isbn-bfpt
		    separate-isbn-afpt
		    comment-isbn-afpt
		    doublequote-date-atpt
		    singlequote-date-atpt
		    parenthese-date-atpt
		    brace-date-atpt
		    bracket-date-atpt
		    doublequote-date-bfpt
		    singlequote-date-bfpt
		    parenthese-date-bfpt
		    brace-date-bfpt
		    bracket-date-bfpt
		    doublequote-date-afpt
		    singlequote-date-afpt
		    parenthese-date-afpt
		    brace-date-afpt
		    bracket-date-afpt
		    separate-date-atpt
		    comment-date-atpt
		    separate-date-bfpt
		    comment-date-bfpt
		    separate-date-afpt
		    comment-date-afpt
		    doublequote-number-atpt
		    singlequote-number-atpt
		    parenthese-number-atpt
		    brace-number-atpt
		    bracket-number-atpt
		    doublequote-number-bfpt
		    singlequote-number-bfpt
		    parenthese-number-bfpt
		    brace-number-bfpt
		    bracket-number-bfpt
		    doublequote-number-afpt
		    singlequote-number-afpt
		    parenthese-number-afpt
		    brace-number-afpt
		    bracket-number-afpt
		    separate-number-atpt
		    comment-number-atpt
		    separate-number-bfpt
		    comment-number-bfpt
		    separate-number-afpt
		    comment-number-afpt
		    doublequote-float-atpt
		    singlequote-float-atpt
		    parenthese-float-atpt
		    brace-float-atpt
		    bracket-float-atpt
		    doublequote-float-bfpt
		    singlequote-float-bfpt
		    parenthese-float-bfpt
		    brace-float-bfpt
		    bracket-float-bfpt
		    doublequote-float-afpt
		    singlequote-float-afpt
		    parenthese-float-afpt
		    brace-float-afpt
		    bracket-float-afpt
		    separate-float-atpt
		    comment-float-atpt
		    separate-float-bfpt
		    comment-float-bfpt
		    separate-float-afpt
		    comment-float-afpt
		    doublequote-page-atpt
		    singlequote-page-atpt
		    parenthese-page-atpt
		    brace-page-atpt
		    bracket-page-atpt
		    doublequote-page-bfpt
		    singlequote-page-bfpt
		    parenthese-page-bfpt
		    brace-page-bfpt
		    bracket-page-bfpt
		    doublequote-page-afpt
		    singlequote-page-afpt
		    parenthese-page-afpt
		    brace-page-afpt
		    bracket-page-afpt
		    separate-page-atpt
		    comment-page-atpt
		    separate-page-bfpt
		    comment-page-bfpt
		    separate-page-afpt
		    comment-page-afpt
		    doublequote-whitespace-atpt
		    singlequote-whitespace-atpt
		    parenthese-whitespace-atpt
		    brace-whitespace-atpt
		    bracket-whitespace-atpt
		    doublequote-whitespace-bfpt
		    singlequote-whitespace-bfpt
		    parenthese-whitespace-bfpt
		    brace-whitespace-bfpt
		    bracket-whitespace-bfpt
		    doublequote-whitespace-afpt
		    singlequote-whitespace-afpt
		    parenthese-whitespace-afpt
		    brace-whitespace-afpt
		    bracket-whitespace-afpt
		    separate-whitespace-atpt
		    comment-whitespace-atpt
		    separate-whitespace-bfpt
		    comment-whitespace-bfpt
		    separate-whitespace-afpt
		    comment-whitespace-afpt
		    doublequote-alnum-atpt
		    singlequote-alnum-atpt
		    parenthese-alnum-atpt
		    brace-alnum-atpt
		    bracket-alnum-atpt
		    doublequote-alnum-bfpt
		    singlequote-alnum-bfpt
		    parenthese-alnum-bfpt
		    brace-alnum-bfpt
		    bracket-alnum-bfpt
		    doublequote-alnum-afpt
		    singlequote-alnum-afpt
		    parenthese-alnum-afpt
		    brace-alnum-afpt
		    bracket-alnum-afpt
		    separate-alnum-atpt
		    comment-alnum-atpt
		    separate-alnum-bfpt
		    comment-alnum-bfpt
		    separate-alnum-afpt
		    comment-alnum-afpt
		    doublequote-alpha-atpt
		    singlequote-alpha-atpt
		    parenthese-alpha-atpt
		    brace-alpha-atpt
		    bracket-alpha-atpt
		    doublequote-alpha-bfpt
		    singlequote-alpha-bfpt
		    parenthese-alpha-bfpt
		    brace-alpha-bfpt
		    bracket-alpha-bfpt
		    doublequote-alpha-afpt
		    singlequote-alpha-afpt
		    parenthese-alpha-afpt
		    brace-alpha-afpt
		    bracket-alpha-afpt
		    separate-alpha-atpt
		    comment-alpha-atpt
		    separate-alpha-bfpt
		    comment-alpha-bfpt
		    separate-alpha-afpt
		    comment-alpha-afpt
		    doublequote-ascii-atpt
		    singlequote-ascii-atpt
		    parenthese-ascii-atpt
		    brace-ascii-atpt
		    bracket-ascii-atpt
		    doublequote-ascii-bfpt
		    singlequote-ascii-bfpt
		    parenthese-ascii-bfpt
		    brace-ascii-bfpt
		    bracket-ascii-bfpt
		    doublequote-ascii-afpt
		    singlequote-ascii-afpt
		    parenthese-ascii-afpt
		    brace-ascii-afpt
		    bracket-ascii-afpt
		    separate-ascii-atpt
		    comment-ascii-atpt
		    separate-ascii-bfpt
		    comment-ascii-bfpt
		    separate-ascii-afpt
		    comment-ascii-afpt
		    doublequote-blank-atpt
		    singlequote-blank-atpt
		    parenthese-blank-atpt
		    brace-blank-atpt
		    bracket-blank-atpt
		    doublequote-blank-bfpt
		    singlequote-blank-bfpt
		    parenthese-blank-bfpt
		    brace-blank-bfpt
		    bracket-blank-bfpt
		    doublequote-blank-afpt
		    singlequote-blank-afpt
		    parenthese-blank-afpt
		    brace-blank-afpt
		    bracket-blank-afpt
		    separate-blank-atpt
		    comment-blank-atpt
		    separate-blank-bfpt
		    comment-blank-bfpt
		    separate-blank-afpt
		    comment-blank-afpt
		    doublequote-cntrl-atpt
		    singlequote-cntrl-atpt
		    parenthese-cntrl-atpt
		    brace-cntrl-atpt
		    bracket-cntrl-atpt
		    doublequote-cntrl-bfpt
		    singlequote-cntrl-bfpt
		    parenthese-cntrl-bfpt
		    brace-cntrl-bfpt
		    bracket-cntrl-bfpt
		    doublequote-cntrl-afpt
		    singlequote-cntrl-afpt
		    parenthese-cntrl-afpt
		    brace-cntrl-afpt
		    bracket-cntrl-afpt
		    separate-cntrl-atpt
		    comment-cntrl-atpt
		    separate-cntrl-bfpt
		    comment-cntrl-bfpt
		    separate-cntrl-afpt
		    comment-cntrl-afpt
		    doublequote-digit-atpt
		    singlequote-digit-atpt
		    parenthese-digit-atpt
		    brace-digit-atpt
		    bracket-digit-atpt
		    doublequote-digit-bfpt
		    singlequote-digit-bfpt
		    parenthese-digit-bfpt
		    brace-digit-bfpt
		    bracket-digit-bfpt
		    doublequote-digit-afpt
		    singlequote-digit-afpt
		    parenthese-digit-afpt
		    brace-digit-afpt
		    bracket-digit-afpt
		    separate-digit-atpt
		    comment-digit-atpt
		    separate-digit-bfpt
		    comment-digit-bfpt
		    separate-digit-afpt
		    comment-digit-afpt
		    doublequote-graph-atpt
		    singlequote-graph-atpt
		    parenthese-graph-atpt
		    brace-graph-atpt
		    bracket-graph-atpt
		    doublequote-graph-bfpt
		    singlequote-graph-bfpt
		    parenthese-graph-bfpt
		    brace-graph-bfpt
		    bracket-graph-bfpt
		    doublequote-graph-afpt
		    singlequote-graph-afpt
		    parenthese-graph-afpt
		    brace-graph-afpt
		    bracket-graph-afpt
		    separate-graph-atpt
		    comment-graph-atpt
		    separate-graph-bfpt
		    comment-graph-bfpt
		    separate-graph-afpt
		    comment-graph-afpt
		    doublequote-lower-atpt
		    singlequote-lower-atpt
		    parenthese-lower-atpt
		    brace-lower-atpt
		    bracket-lower-atpt
		    doublequote-lower-bfpt
		    singlequote-lower-bfpt
		    parenthese-lower-bfpt
		    brace-lower-bfpt
		    bracket-lower-bfpt
		    doublequote-lower-afpt
		    singlequote-lower-afpt
		    parenthese-lower-afpt
		    brace-lower-afpt
		    bracket-lower-afpt
		    separate-lower-atpt
		    comment-lower-atpt
		    separate-lower-bfpt
		    comment-lower-bfpt
		    separate-lower-afpt
		    comment-lower-afpt
		    doublequote-multibyte-atpt
		    singlequote-multibyte-atpt
		    parenthese-multibyte-atpt
		    brace-multibyte-atpt
		    bracket-multibyte-atpt
		    doublequote-multibyte-bfpt
		    singlequote-multibyte-bfpt
		    parenthese-multibyte-bfpt
		    brace-multibyte-bfpt
		    bracket-multibyte-bfpt
		    doublequote-multibyte-afpt
		    singlequote-multibyte-afpt
		    parenthese-multibyte-afpt
		    brace-multibyte-afpt
		    bracket-multibyte-afpt
		    separate-multibyte-atpt
		    comment-multibyte-atpt
		    separate-multibyte-bfpt
		    comment-multibyte-bfpt
		    separate-multibyte-afpt
		    comment-multibyte-afpt
		    doublequote-nonascii-atpt
		    singlequote-nonascii-atpt
		    parenthese-nonascii-atpt
		    brace-nonascii-atpt
		    bracket-nonascii-atpt
		    doublequote-nonascii-bfpt
		    singlequote-nonascii-bfpt
		    parenthese-nonascii-bfpt
		    brace-nonascii-bfpt
		    bracket-nonascii-bfpt
		    doublequote-nonascii-afpt
		    singlequote-nonascii-afpt
		    parenthese-nonascii-afpt
		    brace-nonascii-afpt
		    bracket-nonascii-afpt
		    separate-nonascii-atpt
comment-nonascii-atpt
separate-nonascii-bfpt
comment-nonascii-bfpt
separate-nonascii-afpt
comment-nonascii-afpt
doublequote-print-atpt
singlequote-print-atpt
parenthese-print-atpt
brace-print-atpt
bracket-print-atpt
doublequote-print-bfpt
singlequote-print-bfpt
parenthese-print-bfpt
brace-print-bfpt
bracket-print-bfpt
doublequote-print-afpt
singlequote-print-afpt
parenthese-print-afpt
brace-print-afpt
bracket-print-afpt
separate-print-atpt
comment-print-atpt
separate-print-bfpt
comment-print-bfpt
separate-print-afpt
comment-print-afpt
doublequote-punct-atpt
singlequote-punct-atpt
parenthese-punct-atpt
brace-punct-atpt
bracket-punct-atpt
doublequote-punct-bfpt
singlequote-punct-bfpt
parenthese-punct-bfpt
brace-punct-bfpt
bracket-punct-bfpt
doublequote-punct-afpt
singlequote-punct-afpt
parenthese-punct-afpt
brace-punct-afpt
bracket-punct-afpt
separate-punct-atpt
comment-punct-atpt
separate-punct-bfpt
comment-punct-bfpt
separate-punct-afpt
comment-punct-afpt
doublequote-space-atpt
singlequote-space-atpt
parenthese-space-atpt
brace-space-atpt
bracket-space-atpt
doublequote-space-bfpt
singlequote-space-bfpt
parenthese-space-bfpt
brace-space-bfpt
bracket-space-bfpt
doublequote-space-afpt
singlequote-space-afpt
parenthese-space-afpt
brace-space-afpt
bracket-space-afpt
separate-space-atpt
comment-space-atpt
separate-space-bfpt
comment-space-bfpt
separate-space-afpt
comment-space-afpt
doublequote-unibyte-atpt
singlequote-unibyte-atpt
parenthese-unibyte-atpt
brace-unibyte-atpt
bracket-unibyte-atpt
doublequote-unibyte-bfpt
singlequote-unibyte-bfpt
parenthese-unibyte-bfpt
brace-unibyte-bfpt
bracket-unibyte-bfpt
doublequote-unibyte-afpt
singlequote-unibyte-afpt
parenthese-unibyte-afpt
brace-unibyte-afpt
bracket-unibyte-afpt
separate-unibyte-atpt
comment-unibyte-atpt
separate-unibyte-bfpt
comment-unibyte-bfpt
separate-unibyte-afpt
comment-unibyte-afpt
doublequote-upper-atpt
singlequote-upper-atpt
parenthese-upper-atpt
brace-upper-atpt
bracket-upper-atpt
doublequote-upper-bfpt
singlequote-upper-bfpt
parenthese-upper-bfpt
brace-upper-bfpt
bracket-upper-bfpt
doublequote-upper-afpt
singlequote-upper-afpt
parenthese-upper-afpt
brace-upper-afpt
bracket-upper-afpt
separate-upper-atpt
comment-upper-atpt
separate-upper-bfpt
comment-upper-bfpt
separate-upper-afpt
comment-upper-afpt
doublequote-xdigit-atpt
singlequote-xdigit-atpt
parenthese-xdigit-atpt
brace-xdigit-atpt
bracket-xdigit-atpt
doublequote-xdigit-bfpt
singlequote-xdigit-bfpt
parenthese-xdigit-bfpt
brace-xdigit-bfpt
bracket-xdigit-bfpt
doublequote-xdigit-afpt
singlequote-xdigit-afpt
parenthese-xdigit-afpt
brace-xdigit-afpt
bracket-xdigit-afpt
separate-xdigit-atpt
comment-xdigit-atpt
separate-xdigit-bfpt
comment-xdigit-bfpt
separate-xdigit-afpt
comment-xdigit-afpt
doublequote-region-atpt
singlequote-region-atpt
parenthese-region-atpt
brace-region-atpt
bracket-region-atpt
doublequote-region-bfpt
singlequote-region-bfpt
parenthese-region-bfpt
brace-region-bfpt
bracket-region-bfpt
doublequote-region-afpt
singlequote-region-afpt
parenthese-region-afpt
brace-region-afpt
bracket-region-afpt
separate-region-atpt
comment-region-atpt
separate-region-bfpt
comment-region-bfpt
separate-region-afpt
comment-region-afpt
doublequote-delimited-atpt
singlequote-delimited-atpt
parenthese-delimited-atpt
brace-delimited-atpt
bracket-delimited-atpt
doublequote-delimited-bfpt
singlequote-delimited-bfpt
parenthese-delimited-bfpt
brace-delimited-bfpt
bracket-delimited-bfpt
doublequote-delimited-afpt
singlequote-delimited-afpt
parenthese-delimited-afpt
brace-delimited-afpt
bracket-delimited-afpt
separate-delimited-atpt
comment-delimited-atpt
separate-delimited-bfpt
comment-delimited-bfpt
separate-delimited-afpt
comment-delimited-afpt)))
    (save-excursion 
      (dolist (elt fns-test)
	(message "   %s" elt)
	(save-excursion (funcall elt))
	(sit-for thatpt-delimtest-delay))))
  (undo))

(provide 'thatpt-utils-test)
;;; thatpt-utils-test.el ends here
